Package org.apache.sysds.runtime.util

## Class AutoDiff

- java.lang.Object
- - org.apache.sysds.runtime.util.AutoDiff

    public class AutoDiff
    extends Object

### Constructor Summary

Constructors
`AutoDiff()`

### Method Summary

All Methods Static Methods Concrete Methods
`static ArrayList<Hop>` `constructHopsNR​(LineageItem item, Map<Long,​Hop> operands, Hop mo, ArrayList<String> names)`
`static ListObject` `getBackward​(MatrixObject mo, ArrayList<Data> lineage, ExecutionContext adec)`
`static List<Data>` `parseNComputeAutoDiffFromLineage​(MatrixObject mo, String mainTrace, ArrayList<String> names, ExecutionContext ec)`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### AutoDiff

    public AutoDiff()

### Method Detail

#### getBackward

    public static ListObject getBackward​(MatrixObject mo,
                                         ArrayList<Data> lineage,
                                         ExecutionContext adec)

#### parseNComputeAutoDiffFromLineage

    public static List<Data> parseNComputeAutoDiffFromLineage​(MatrixObject mo,
                                                              String mainTrace,
                                                              ArrayList<String> names,
                                                              ExecutionContext ec)

#### constructHopsNR

    public static ArrayList<Hop> constructHopsNR​(LineageItem item,
                                                 Map<Long,​Hop> operands,
                                                 Hop mo,
                                                 ArrayList<String> names)